# STM32CubeMP1 MPU Firmware Package

**STM32Cube** is an STMicroelectronics original initiative to ease the developers life by reducing efforts, time and cost.

**STM32Cube** covers the overall STM32 products portfolio. It includes a comprehensive embedded software platform (this repo), delivered for each series (such as the STM32CubeMP1 for the STM32MP1 series).
   * The CMSIS modules (core and device) corresponding to the ARM tm core implemented in this STM32 product
   * The STM32 HAL-LL drivers : an abstraction drivers layer, the API ensuring maximized portability across the STM32 portfolio 
   * The BSP Drivers of each evaluation or demonstration board provided by this STM32 series 
   * A consistent set of middlewares components (FreeRTOS and OpenAMP)
   * A full set of software projects (basic examples, applications or demonstrations) for each board provided by this STM32 series
   
The **STM32CubeMP1 MPU Package** projects are directly running on Cortex-M4 of the STM32MP1 series boards. You can find in each Projects/*Board name* directories a set of software projects (Applications/Demonstration/Examples) 

## Boards available
  * STM32MP1
    * STM32MP157C-EV1 RevC
    * STM32MP157C-DK2 RevC