#!/bin/sh
CONFIG_FILE=./production.config

if [ ! -e ${CONFIG_FILE} ]
then
  echo "${CONFIG_FILE} was not found, copying default production.config file"
  cp $1/production.config ${CONFIG_FILE} ; chmod +rw ${CONFIG_FILE}
fi

echo "Using board's hostname or IP address specified in ${CONFIG_FILE}"
source ${CONFIG_FILE}

DTC=$1/dtc
CPP=$3/ARM/ARMCLANG/bin/armclang

cd DeviceTree
echo "Run preprocessor on $DT.dts"
cp $DT.dts $DT.S
${CPP} --target=arm-arm-none-eabi -mcpu=cortex-m4 ${INCLUDES} -E $DT.S > $DT.dts.tmp

echo "Generate device tree $DT.dtb"
${DTC} -@ -O dtb -b 0 -i ${STAGING_KERNEL_DIR}/arch/arm/boot/dts/ -d $DT.d.dtc.tmp -o $DT.dtb $DT.dts.tmp
rm $DT.S $DT.d.dtc.tmp $DT.dts.tmp

echo "Load $DT.dtb into ${BOARD_HOSTNAME}/boot/"
scp -oStrictHostKeyChecking=no -r $DT.dtb root@${BOARD_HOSTNAME}:/boot/$DT.dtb
