#!/bin/sh
CONFIG_FILE=./production.config

if [ ! -e ${CONFIG_FILE} ]
then
  echo "${CONFIG_FILE} was not found, copying default production.config file"
  cp $1/production.config ${CONFIG_FILE} ; chmod +rw ${CONFIG_FILE}
fi

echo "Using board's hostname or IP address specified in ${CONFIG_FILE}"
source ${CONFIG_FILE}

echo "Ping ${BOARD_HOSTNAME}"
if [[ $(ping -n 1 ${BOARD_HOSTNAME} | awk -F'host' '{print $2}') == *"unreachable"* ]]; then
  echo "Error: check board's network connection!"
  exit 1
fi

echo "Restart ${BOARD_HOSTNAME}"
ssh -oStrictHostKeyChecking=no root@${BOARD_HOSTNAME} "bash -s" < $1/restart_m4.sh
